const portfolioApp = Vue.component('portfolioApp',{//only show mobile under HERO
  props:{
    'deviceW' : Number,
  },
  data : function(){
    return {
      'pfImgA'   : [],
      'pfHrefA'  : [],
      'styleSec' : {
        'min-height' : 'calc(100vh - 3em)',
      },
      stylePF : {
        'min-height'              : '10px',
        'width'                   : '156px',
        'height'                  : '156px',
        'margin'                  : '15% auto',
        'display'                 : 'flex',
        'align-items'             : 'center',
        '-webkit-align-items'     : 'center',//for safari
        'justify-content'         : 'center',
        '-webkit-justify-content' : 'center',//for safari
      },
      stylePFmb: {
        'min-height'              : '10px',
        'width'                   : '95px',
        'height'                  : '95px',
        'margin'                  : '15% auto',
        'display'                 : 'flex',
        'align-items'             : 'center',
        '-webkit-align-items'     : 'center',//for safari
        'justify-content'         : 'center',
        '-webkit-justify-content' : 'center',//for safari
      },
      stylePFe : {
        'min-height'              : '3rem',
        'width'                   : '156px',
        'height'                  : '156px',
        'margin'                  : '15% auto',
        'padding'                 : '0 3rem 0 3rem',
        'display'                 : 'flex',
        'align-items'             : 'center',
        '-webkit-align-items'     : 'center',//for safari
        'justify-content'         : 'center',
        '-webkit-justify-content' : 'center',//for safari
      },
      stylePFmbe: {
        'min-height'              : '3rem',
        'margin'                  : '15% auto',
        'display'                 : 'flex',
        'align-items'             : 'right',
        '-webkit-align-items'     : 'right',//for safari
        'justify-content'         : 'right',
        '-webkit-justify-content' : 'right',//for safari
      },

      stylePFBoxs : {
        'padding' : '0',
      },
      stylePFFoot : {
        'margin-bottom' : '3rem',
      },
      styleGFont  : {
        'font-family' : '"Poiret One", cursive!important',
      },
      styleBorderRed : {
        'border-bottom' : '#C00 1px solid',
        'margin-bottom' : '1.6rem',
      },
      styleH3Mergin  : {
        'margin-bottom' : '1.5rem',
      },
      styleRed       : {
        'color' : '#C00',
      },
      styleBGI : {
        'background-image'    : 'url("../img/portfolio.jpg")',
        'background-repeat'   : 'no-repeat',
        'background-position' : 'center',
        'background-size'     : 'cover',
      },
      'styleQuarterVH' : {
        'min-height' : '25VH',
      },
      'classBGC' : 'has-background-white-ter',
    };
  },
  created() {
    let pfImg  = [];
    let pfNum  = 70;//PORTFOLIO検索数
    let pfHref = [];
    async function fPfFetch(){
      for(let i = 0; i < pfNum ; i++){
         fetch('../pfImg/' + i + '.jpg',{headers : {'Content-type' : 'image/jpeg'}}).then(function(response){
          if(response.ok){
            //text
            fetch('../pfImg/' + i + '.txt',{headers : {'Content-type' : 'text/plain'}}).then(function(response){
              if(response.ok){
                response.text().then(function(text){
                  pfHref[i] = text.replace(/\r?\n/g,'');//cut off rn n r
                  pfHref.splice();
                });
              }
              if(response.status == '404'){
              }
            });
            //img
            response.blob().then(function(img){
              pfImg[i] = img;
              pfImg.splice();
            });
          }else{
            //throw new Error('got img');
          }
        });
      }
    }
    fPfFetch();

    pfImg.filter(function(v){return v != null;});
    pfHref.filter(function(v){return v != null;});
    this.pfImgA  = pfImg;
    this.pfHrefA = pfHref;

  },
  template : `
    <div class="has-background-white-ter">
      <header class="hero is-medium is-marginless" :style="[styleBGI,styleBorderRed]">
        <div class="hero-body" >
          <section class="container" >
            <div class="columns" :style="styleQuarterVH">
              <div class="column is-4">
                <div class="is-vertical">
                  <h1 class="is-size-2" :style="[styleGFont,styleRed,styleBorderRed]">PORTFOLIO</h1>
                </div>
              </div>
            </div>
          </section>
        </div>
      </header>
      <main :class="['section',classBGC]">
        <section class="container">
          <div class="columns is-multiline is-mobile">
            <div class="column">
              <div class="columns is-multiline is-mobile is-vcentered">
                <div :class="[deviceW < 723 ? 'is-4' : 'is-3', 'column','is-vcentered','is-centered','is-paddingless']" v-for="(value,item,index) in pfImgA" :v-key="item" v-if="value != undefined">
                  <figure class="image" :style="[deviceW < 723 ? stylePFmb : stylePF]">
                    <a :href="'' + pfHrefA[item]" target="_blank" rel="noopener">
                      <img alt="portfolio" :src="'../pfimg/' + item + '.jpg'">
                    </a>
                  </figure>
                </div>
                <hr>
              </div>
            </div>
          </div>
        </section>
      </main>
    </div>
  `
});


const team = new Vue({
  el : '#portfolio',
  components:{
    'aNav'     : aNav,
    'app'      : portfolioApp,
    'aFooter'  : aFooter,
  },
  data : function(){
    return {
      'deviceW' : window.innerWidth,
    };
  },
  template : `
    <div>
      <aNav :deviceW="deviceW">
      </aNav>
      <app :deviceW="deviceW">
      </app>
      <aFooter :deviceW="deviceW">
      </aFooter>
    </div>
  `,
});

